Subject: [Stackevo] cross-SDO "DHCPv6 vs RA" issues

From: Dave Thaler <[email-masked]>
Date: Thu, 11 Dec 2014 21:59:11 +0000

I wanted to kick off a discussion within a small group of people who can consider cross-SDO
impacts of IP configuration issues.  As most of you are acutely aware, the IETF often gets into
"DHCPv6 vs RA option" debates ad nauseum.   At the risk of starting another one here among
this small-ish and hopefully clueful set of people...

Background on IAB position:
In 2009, the IAB published RFC 5505 on "Principles of Internet Host Configuration" on this
sort of topic, which was motivated in part due to people trying to put IP-and-higher configuration
options into L2 protocols, much as IPCP historically did for IPv4 over PPP, and IPCP6 for IPv6
removed.  The RFC contains many relevant statements, especially in 2.3, 3.1, and 3.2.1.  For
example section 2.3 starts "The number of host configuration mechanisms should be minimized."
RFC 1958 says "3.2 If there are several ways of doing the same thing, choose one.", but 
RFC 5505 elaborates further by saying that for *different* types of data there may be
different solutions appropriate, and does give examples around Router Advertisements
(section 3.2.1) and DHCP (section 3.1).

Current state:
For just about every new host configuration knob, we often see proposals for doing it using DHCP,
proposals for doing it using RAs, and even proposals for encapsulating DHCP options in general
in RAs, or encapsulating RA options in general in DHCP.   These debates are not in line with
good architecture.   The rationale to put RA information in DHCP typically stems from the
claim that RAs do not support giving different information to different hosts, which some see
as a requirement; this was true but is being (and IMO should be!) addressed in the IETF.
The rationale to put DHCP information in RAs instead steps from the issue that another SDO
(usually 3GPP is cited) "doesn't do DHCPv6".   The IETF already distinguishes between 
DHCPv6-for-addressing, which is not mandatory, vs DHCP-for-other-information-only (aka
DHCPv6 lite, aka stateless DHCPv6) and it's the latter we're talking about here.

Issue:
Since the IETF "debate ad nauseum" issue appears, to me anyway, to stem from issues
caused or reported by other SDOs, can anyone explain why they have such a stance
since it causes the IETF so much pain?   Should the IETF take a harder line and tell (in a nice way)
such SDOs to do DHCPv6-lite and stop causing us so much grief?  Yes I know there's the issue
of deployed base that will continue causing grief regardless, but I'm thinking long term strategic.

Let the lively discussion begin :)

-Dave

---

From: Xing Li <[email-masked]>
Date: Mon, 15 Dec 2014 09:59:31 +0800

Thanks, Dave. This is a very important issue. As an operator of running 
IPv6 networks (CERNET2), I would like to see the progress. xing

Dave Thaler 写道:
> _______________________________________________
> Stackevo mailing list
> [email-masked]
> https://www.iab.org/mailman/listinfo/stackevo
>
>
>

---

From: Brian Trammell <[email-masked]>
Date: Mon, 15 Dec 2014 11:02:24 +0100

hi Dave, all,

> On 11 Dec 2014, at 22:59, Dave Thaler <[email-masked]> wrote:
> 
> good architecture.

Nope. But they are in line with the philosophy of development of and perceptions about the applicability of DHCP and RA, and the history of deployment (especially) of DHCP. 

Dual-stack environments that already have an investment in DHCPv4 infrastructure (let's say for the sake of simplification "all of them") tend to want to run DHCPv6, if only because the protocols support roughly the same feature set, are often offered together by the same server stack, and have the same name.

AFAICT, the arguments in favor of RA have to do with the "v6-ness" of RA, and make somewhat more sense in the alternate universe in which there are large, non-dual-stack, non-"transition" networks. And in the interests of full disclosure: (1) From an ideology standpoint I'm a bit fan of RA + SLAAC + 4941, but (2) I ran my last real network in 1999 so take everything I say with a grain of salt.

> The rationale to put RA information in DHCP typically stems from the

With IAB liaison-management glasses on this looks like an SDO-opinion problem. But I think it's got a somewhat wider basis than that.

Anecdata: my desktop at v6-friendly ETH has a v4 address DHCP-assigned to my MAC *and* port out of a /23, and a v6 DHCP-v6 assigned out of a /115. There is an algorithmic mapping between addresses in v4 and v6, I presume to make the monitoring tools' life less join-y. There are people who do sysadmin here who are deeply annoyed with this arrangement, because it is "not very v6". They could certainly do the same thing with RAs -- we don't get any other oddball system configuration out of DHCPv4 -- but they don't.

> of deployed base that will continue causing grief regardless, but I'm thinking long term strategic.

So it's been a while since I looked into the details here as to the feature-set (and security model vulnerability) gaps between RA and DHCPv6-lite. I think I'd also want to know something about deployment numbers before forming an opinion on what the IETF should say and how loudly.

Cheers,

Brian